<?php if ( ! defined( 'ABSPATH' ) ) exit; 
/*
	Plugin Name: Export Variable Products
	Plugin URI: https://wordpress.org/plugins/export-variable-products
	Description: Using WooCommerce in combination with this plugin you can Export Variable Products.
	Version: 1.2.7
	Author: Fahad Mahmood
	Author URI: http://androidbubble.com/blog/
	Text Domain: woo-evp
	Domain Path: /languages/	
	License: GPL2
	
	
	This WordPress plugin is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 2 of the License, or
	any later version.
	 
	This WordPress plugin is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
	GNU General Public License for more details.
	 
	You should have received a copy of the GNU General Public License
	along with this WordPress plugin. If not, see http://www.gnu.org/licenses/gpl-2.0.html.
*/


	if ( ! defined( 'ABSPATH' ) ) {
		exit; // Exit if accessed directly
	}else{
		 clearstatcache();
	}
	
	require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
	
	$wevp_all_plugins = get_plugins();
	$wevp_active_plugins = apply_filters( 'active_plugins', get_option( 'active_plugins' ) );
	
	if ( array_key_exists('woocommerce/woocommerce.php', $wevp_all_plugins) && in_array('woocommerce/woocommerce.php', $wevp_active_plugins) ) {
		
		
		
		
		global $wevp_url, $wevp_dir, $wevp_data, $wevp_pro, $wevp_premium_copy, $wevp_bulk_instantiated, $wevp_activated;
	
		$wevp_bulk_instantiated = false;
		$wevp_activated = true;
		
		$wevp_premium_copy = 'https://shop.androidbubbles.com/product/export-variable-products';		
		$wevp_data = get_plugin_data(__FILE__);
		$wevp_url = plugin_dir_url(__FILE__);
        $wevp_dir = plugin_dir_path(__FILE__);

		define( 'WEVP_PLUGIN_DIR', dirname( __FILE__ ) );
	
		$wevp_pro_file = WEVP_PLUGIN_DIR . '/pro/wevp-pro.php';
		
		
		$wevp_pro =  file_exists($wevp_pro_file);
		
		
		require_once WEVP_PLUGIN_DIR . '/inc/functions.php';
		
		
		if($wevp_pro)
		include_once($wevp_pro_file);
		
		if(is_admin()){
			
			add_action( 'admin_menu', 'wevp_admin_menu' );	
			
			if(function_exists('wevp_plugin_linx')){
				$plugin = plugin_basename(__FILE__); 
				add_filter("plugin_action_links_$plugin", 'wevp_plugin_linx' );	
			}
			//global $post;
			//pree($post);
			
			//pree($get_post);
			if(function_exists('wevp_admin_scripts') && isset($_GET['post']) ){
				$get_post = get_post(esc_attr($_GET['post']));


				if(is_object($get_post) && $get_post->post_type=='product'){				
					
					//$product = wc_get_product($get_post->ID);
					$args = array(
										'post_parent' => $get_post->ID,
										'post_type' => 'product_variation',
										'post_status'      => 'publish',
							);
									
					$children = get_posts($args);
					//pree(get_post_meta($get_post->ID));
					//pree($args);
					//pree($children);
					
					if ( !empty($children)) {
						add_action( 'admin_enqueue_scripts', 'wevp_admin_scripts', 99 );	
					}
				}
			}
			
		}else{
			if(function_exists('wevp_front_scripts'))
			add_action( 'wp_enqueue_scripts', 'wevp_front_scripts', 99 );	
		}
		
	}

